//=========================================================================
//A temporary thing in case an error occurs
//=========================================================================

local feedbackRelay = SpawnEntityFromTable("logic_relay", {
    targetname = "TF2M_FeedbackRoundRelay",
    spawnflags = 0,
    "OnTrigger": "!self,RunScriptCode,main_script_entity.TerminateScriptScope(),0,-1",
});

::detectedIssues <- {};

::ErrorHandler <- function(e)
{
    local stackInfo = getstackinfos(2);
    local key = format("'%s' @ %s#%d", e, stackInfo.src, stackInfo.line);

    if (!(key in detectedIssues))
    {
        detectedIssues[key] <- [e, 1];
        foreach(player in FindValidPlayers())
            PrintError(player, "A NEW ERROR HAS OCCURRED", e);
    }
    else
    {
        detectedIssues[key][1]++;
        foreach(player in FindValidPlayers())
            ClientPrint(player, 3, format("A ERROR HAS OCCURRED [%d] TIMES: [%s]", detectedIssues[key][1], key));
    }
}
seterrorhandler(ErrorHandler);

::FindSourceTV <- function()
{
    for (local i = 1; i <= MAX_PLAYERS; i++)
        if (PlayerInstanceFromIndex(i) == null)
        {
            local entity = EntIndexToHScript(i);
            if (entity && entity.IsPlayer())
                return entity;
        }
    return null;
}

::FindValidPlayers <- function()
{
    local devs = [];
    foreach (player in GetClients())
        devs.push(player);
    local stv_player = FindSourceTV();
    if (stv_player)
        devs.push(stv_player);
    return devs;
}

::PrintError <- function(player, title, e, printfunc = null)
{
    if (!printfunc)
        printfunc = @(m) ClientPrint(player, 3, m);
    printfunc(format("\n%s [%s]", title, e))
    printfunc("CALLSTACK")
    local s, l = 3
    while (s = getstackinfos(l++))
        printfunc(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    printfunc("LOCALS")
    if (s = getstackinfos(3))
        foreach (n, v in s.locals)
        {
            local t = type(v)
            t ==    "null" ? printfunc(format("[%s] NULL"  , n))    :
            t == "integer" ? printfunc(format("[%s] %d"    , n, v)) :
            t ==   "float" ? printfunc(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? printfunc(format("[%s] \"%s\"", n, v)) :
                             printfunc(format("[%s] %s %s" , n, t, v.tostring()))
        }
}